import { HttpBackend, HttpContextToken, HttpEvent, HttpRequest } from 'angular-miniprogram/common/http';
import { Observable } from 'rxjs';
/** Use this token to pass additional `wx.uploadFile()` parameter */
export declare const UPLOAD_FILE_TOKEN: HttpContextToken<{
    filePath?: string | undefined;
    name?: string | undefined;
    timeout?: number | undefined;
}>;
/** Use this token to pass additional `wx.downloadFile()` parameter */
export declare const DOWNLOAD_FILE_TOKEN: HttpContextToken<{
    filePath?: string | undefined;
    timeout?: number | undefined;
}>;
/** Use this token to pass additional `wx.request()` parameter */
export declare const REQUSET_TOKEN: HttpContextToken<{
    enableCache?: boolean | undefined;
    enableHttp2?: boolean | undefined;
    enableQuic?: boolean | undefined;
    timeout?: number | undefined;
}>;
export declare class MiniprogramHttpBackend implements HttpBackend {
    handle(request: HttpRequest<any>): Observable<HttpEvent<any>>;
    /**
     * wx upload file
     * @param request
     */
    private upload;
    /**
     * wx download file
     * @param request
     */
    private download;
    /**
     * wx http request
     * @param request
     */
    private request;
    private buildHeaders;
}


